#include <iostream>
#include <string>
using namespace std;

struct Person {
 string name;
 unsigned int age;
 Person *next;
};

Person *start_ptr = NULL;
Person *current;
int option = 0;

void addPerson();
void display_list();
void updPerson();
void delPerson();
void free_list();

int main() {
 start_ptr = NULL;
 do {
  cout << endl;
  cout << "Select an option : " << endl;
  cout << "0. Exit the program." << endl;
  cout << "1. Insert a name to the list." << endl;
  cout << "2. Delete a name from the list." << endl;
  cout << "3. Update  a name from the list." << endl;
  cout << "4. Print the list." << endl;
  cout << endl << " >> ";
  cin >> option;
  switch (option) {
   case 1 :
     addPerson();
     break;
   case 2 :
     delPerson();
     break;
   case 3 :
     updPerson();
     break;
   case 4 :
     display_list();
     break;
  }
 while (option != 0);

  }
 free_list();
}


void addPerson() {
 Person *temp, *temp2;

 temp = new Person;
 cout << "Enter the name of the person: ";
 cin >> temp->name;
 cout << "Enter the age of the person : ";
 cin >> temp->age;
 temp->next = NULL;

 if (start_ptr == NULL)
 {
  start_ptr = temp;
  current = start_ptr;
    }

    else
    {
     temp2 = start_ptr;

  while (temp2->next != NULL)
  {
   temp2 = temp2->next;

  }
  temp2->next = temp;
 }
}

void display_list() {
 Person *temp;
 temp = start_ptr;
 cout << endl;
 if (temp == NULL)
  cout << "The list is empty.." << endl;
 else
 {
  while (temp != NULL)
  {

   cout << "NAME : " << temp->name << " ";
   cout << "AGE : " << temp->age << " ";
        if (temp == current)
    cout << " <---- first node";

   cout << endl;
   temp = temp->next;
  }
  cout << "End of list!" << endl;
 }
}

void updPerson() {
 string name;
 Person *temp;
 temp = start_ptr;

 if(temp==NULL)
  cout << "\n List is empty !!!\n";

 else
 {
  cout << "Enter name to find: ";
  cin >> name;
  while(temp!=NULL)
  {
   if(temp->name==name )
   {
    cout << "Enter the new name : ";
    cin >> temp -> name;
    cout << "Enter the new age : ";
    cin >> temp -> age;
    return;
   }

   temp=temp->next;
  }
 }

 if(temp != NULL)
    cout << "\nName not found in the list\n";
}

void delPerson() {
 Person *temp, *prev;
 string name;

 temp = prev = start_ptr;


 if(temp == NULL)
  cout << "\nList is empty !!!\n";
 else
 {
  cout << "Enter the name to be deleted: ";
  cin >> name;

  while(temp != NULL)
  {
   if(temp -> name == name)
   {
    if(temp == prev)
    {
     temp = temp -> next;
     delete start_ptr;
     start_ptr = current = temp;
     cout << "Person " << name << " is deleted\n" ;
     return;
    }
    else
    {
     prev -> next = temp -> next;
     delete temp;
     cout << "Person " << name << " is deleted\n" ;
     return;
    }
   }
   prev = temp;
   temp = temp -> next;
  }
  cout << "\nName not found in the list\n";
 }
}
void free_list() {
 Person *temp_ptr;
 while ( start_ptr != 0 )
 {
  temp_ptr = start_ptr -> next;
  delete start_ptr;
  start_ptr = temp_ptr;
 }
}
