// Program by
// Abdullah S. Al-Salloum
// Hussain Al-Sane
// Instructed by: Dr. Ashraf Anwar



#include <iostream>
#include <string>

using namespace std;

// class Student ...

class Student {
	public:

	// Public Section Accessor Methods ...

	void setName( string n ) { name = n; }
	void setBirth( string b ) { dateofbirth = b; }
	void setNationality( string na ) { nationality = na; }
	void setGPA( float g ) { gpa = g; }
	void setMajor( string m ) { major = m; }
	void setCredits( int c ) { credits = c; }
	void setPhone( int p ) { phonenumber = p; }
	void setAddress( string ad ) { address = ad; }
	void setGender( char gen ) { gender = gen; }
	string getName() { return name; }
	string getBirth() { return dateofbirth; }
	string getNationality() { return nationality; }
	float getGPA() { return gpa; }
	string getMajor() { return major; }
	int getCredits() { return credits; }
	int getPhone() { return phonenumber; }
	string getAddress() { return address; }
	char getGender() {return gender; }

    // The class properties ...

	private:
	string name;
	string nationality;
	string major;
	string dateofbirth;
	float gpa;
	int credits;
	int phonenumber;
	string address;
	char gender;
};


// Add Student function definition ...

void addstudent(Student student[], int nostbe) {
	int j;
	string n;
	string na;
	string b;
	string m;
	float g;
	char gen;
	int p;
	string ad;
	int c;
	for( int i=0; i < nostbe; i++ ) {
		j = i + 1;
		cout << "------ Insert Student # " << j << " Information ------" << '\n';
		cout << "What's the name of student number " << j << "?" << '\n';
		cin >> n;
		student[i].setName(n);
		cout << "What's the nationality of student number " << j << "?" << '\n';
		cin >> na;
		student[i].setNationality(na);
		cout << "What's the birth year of student number " << j << "?" << '\n';
		cin >> b;
		student[i].setBirth(b);
		cout << "What's the major of student number " << j << "?" << '\n';
		cin >> m;
		student[i].setMajor(m);
		cout << "What's the GPA of student number " << j << "?" << '\n';
		cin >> g;
		student[i].setGPA(g);
		cout << "What's the number of done credits of student number " << j << "?" << '\n';
		cin >> c;
		student[i].setCredits(c);
		cout << "What's the phone number of student number " << j << "?" << '\n';
		cin >> p;
		student[i].setPhone(p);
		cout << "What's the Address of student number " << j << "?" << '\n';
		cin >> ad;
		student[i].setAddress(ad);
		cout << "What's the Gender of student number " << j << "?" << '\n';
		cin >> gen;
		student[i].setGender(gen);
		cout << "------ Done From Inserting Student # " << j << " Information ------" << '\n';
	}
}

// Update student function definition ...

void updatestudent(Student student[], int nostbu, int nostbe) {
	int nostbu2;
	string n;
	string na;
	string b;
	string m;
	float g;
	char gen;
	int p;
	string ad;
	int c;
	nostbu2 = nostbu - 1;
	cout << student[nostbu2].getName() << '\n'
		 << student[nostbu2].getNationality() << '\n'
		 << student[nostbu2].getBirth() << '\n'
		 << student[nostbu2].getMajor() << '\n'
		 << student[nostbu2].getGPA() << '\n'
		 << student[nostbu2].getCredits() << '\n'
		 << student[nostbu2].getPhone() << '\n'
		 << student[nostbu2].getAddress() << '\n'
		 << student[nostbu2].getGender() << endl;
	cout << "-----Please Insert The New Information-----" << '\n';
	cout << "What's the new name of student number " << nostbu << "?" << '\n';
	cin >> n;
	student[nostbu2].setName(n);
	cout << "What's the new nationality of student number " << nostbu << "?" << '\n';
	cin >> na;
	student[nostbu2].setNationality(na);
	cout << "What's the new birth year of student number " << nostbu << "?" << '\n';
	cin >> b;
	student[nostbu2].setBirth(b);
	cout << "What's the new major of student number " << nostbu << "?" << '\n';
	cin >> m;
	student[nostbu2].setMajor(m);
	cout << "What's the new GPA of student number " << nostbu << "?" << '\n';
	cin >> g;
	student[nostbu2].setGPA(g);
	cout << "What's the new number of done credits of student number " << nostbu << "?" << '\n';
	cin >> c;
	student[nostbu2].setCredits(c);
	cout << "What's the new phone number of student number " << nostbu << "?" << '\n';
	cin >> p;
	student[nostbu2].setPhone(p);
	cout << "What's the new address of student number " << nostbu << "?" << '\n';
	cin >> ad;
	student[nostbu2].setAddress(ad);
	cout << "What's the new gender of student number " << nostbu << "?" << '\n';
	cin >> gen;
	student[nostbu2].setGender(gen);
	cout << "-----Done From Inserting The New Information-----" << '\n';
}

// List student function definition ...

void liststudents(Student student[], int nostbe) {
	int j;
	for (int i=0; i < nostbe ; i++) {
		j = i + 1;
		cout << "-----------------------" << '\n'
			 << "Student number " << j << '\n'
		     << "Name: " << student[i].getName() << '\n'
		     << "Nationality: " << student[i].getNationality() << '\n'
		     << "Year of birth: " << student[i].getBirth() << '\n'
			 << "Gender: " << student[i].getGender() << '\n'
			 << "Major: " << student[i].getMajor() << '\n'
			 << "GPA: " << student[i].getGPA() << '\n'
			 << "Credits: " << student[i].getCredits() << '\n'
			 << "Phone: " << student[i].getPhone() << '\n'
			 << "Address: " << student[i].getAddress() << '\n'
			 << "-----------------------" << endl;
	}
}

// Undergraduate list function definition ...

void undergraduate(Student student[], int nostbe) {
	cout << "Names shown below are the students who are undergraduate students" << endl;
	for (int i=0; i < nostbe ; i++) {
		if ( student[i].getCredits() < 90 ) {
			cout << student[i].getName() << '\n';
		}
	}
}

// Graduate list function definition ...

void graduate(Student student[], int nostbe) {
	cout << "--------------------------------------------------" << '\n';
	cout << "Names shown below are the students who are graduate students" << endl;
	for (int i=0; i < nostbe ; i++) {
		if ( student[i].getCredits() >= 90 ) {
			cout << student[i].getName() << '\n';
		}
	}
	cout << "--------------------------------------------------" << '\n';
}

// Dean's list function definition ...

void deanslist(Student student[], int nostbe) {
	cout << "--------------------------------------------------" << '\n';
	cout << "Names shown below are the students who are in the dean's list" << endl;
		for (int i=0; i < nostbe ; i++) {
			if ( student[i].getGPA() >= 3.25 ) {
				cout << student[i].getName() << '\n';
			}
		}
	cout << "--------------------------------------------------" << '\n';
}

// Warned list function definition ...

void warned(Student student[], int nostbe) {
	cout << "--------------------------------------------------" << '\n';
	cout << "Names shown below are the students who are in the warning list" << endl;
		for (int i=0; i < nostbe ; i++) {
			if ( student[i].getGPA() < 2.00 ) {
				cout << student[i].getName() << '\n';
			}
		}
	cout << "--------------------------------------------------" << '\n';
}

// Specific major students list function definition ...

void majorgrouping(Student student[], int nostbe) {
	string majoring;
	cout << "What Major students list you are looking for?" << endl;
	cin >> majoring;
	cout << "--------------------------------------------------" << '\n';
	cout << "Names shown below are the students who are majoring in"<< majoring << endl;
	for (int i=0; i < nostbe ; i++) {
		if ( student[i].getMajor() == majoring ) {
			cout << student[i].getName() << '\n';
		}
	}
	cout << "--------------------------------------------------" << '\n';
}

// Specific nationality students list function definition ...

void nationalitygrouping(Student student[], int nostbe) {
	string nationalitying;
	cout << "What Nationality students list you are looking for?" << endl;
	cin >> nationalitying;
	cout << "--------------------------------------------------" << '\n';
	cout << "Names shown below are the students who their nationality is"<< nationalitying << endl;
	for (int i=0; i < nostbe ; i++) {
		if ( student[i].getNationality() == nationalitying ) {
			cout << student[i].getName() << '\n';
		}
	}
	cout << "--------------------------------------------------" << '\n';
}

// Specific birth year students list function definition ...

void birthgrouping(Student student[], int nostbe) {
	string yearofbirthing;
	cout << "What year of birth students list you are looking for?" << endl;
	cin >> yearofbirthing;
	cout << "--------------------------------------------------" << '\n';
	cout << "Names shown below are the students who their year of birth is"<< yearofbirthing << endl;
	for (int i=0; i < nostbe ; i++) {
		if ( student[i].getBirth() == yearofbirthing ) {
			cout << student[i].getName() << '\n';
		}
	}
	cout << "--------------------------------------------------" << '\n';
}

// Starting function definition ...

void starting(int nostbe, Student student[]) {
	int nostbu, nostbd, option;
	cout << "--------------------Menu----------------------" << '\n'
		 << "Press 1 to create a students list" << '\n'
		 <<	"Press 2 to update a student" << '\n'
		 <<	"Press 3 to sort students list" << '\n'
		 <<	"Press 4 to list undergraduate students list" << '\n'
		 <<	"Press 5 to list graduate students list" << '\n'
		 <<	"Press 6 to list students who are in the dean's list" << '\n'
		 <<	"Press 7 to list students who are warned" << '\n'
		 <<	"Press 8 to list students in a specific major" << '\n'
		 <<	"Press 9 to list students who have the same nationality" << '\n'
		 <<	"Press 10 to list students who were born in the same year" << '\n'
		 << "--------------------Menu----------------------" << '\n';
	cin >> option;

	switch (option) {
	   case 1 :
	     {
	         addstudent(student, nostbe);
	         starting(nostbe, student);
		 }
	     break;
	   case 2 :
	     {
	   		 cout << "What's the number of student you want to update? " << '\n';
	   		 cin >> nostbu;
	   		 if ( nostbu <= nostbe ) {
	   	     	updatestudent(student, nostbu, nostbe);
		 	 }
		 	 else {
			 		cerr << "The number of student you have entered in invalid!" << '\n';
			 }
	   	     starting(nostbe, student);
		 }
	     break;
	   case 3 :
	     {
	         liststudents(student, nostbe);
	         starting(nostbe, student);
	     }
	     break;
	   case  4 :
	     {
		     undergraduate(student, nostbe);
		     starting(nostbe, student);
		 }
	     break;
	   case 5 :
	     {
	       	 graduate(student, nostbe);
	       	 starting(nostbe, student);
		 }
	     break;
	   case 6 :
	     {
	   	     deanslist(student, nostbe);
	   	     starting(nostbe, student);
		 }
	     break;
	   case 7 :
	     {
		     warned(student, nostbe);
		     starting(nostbe, student);
		 }
	     break;
	   case 8 :
	     {
		     majorgrouping(student, nostbe);
		     starting(nostbe, student);
		 }
	     break;
	   case 9 :
	     {
		     nationalitygrouping(student, nostbe);
		     starting(nostbe, student);
		 }
	     break;
	   case 10 :
	     {
	   	     birthgrouping(student, nostbe);
	   	     starting(nostbe, student);
		 }
	     break;
	   default :
	     {
	         cerr << "The option you have entered in invalid!" << '\n';
	         starting(nostbe, student);
		 }
	     break;
	 }

}


// Main function definition ...

int main() {
	int nostbe;
	cout << "Welcome to the University Student's Database!" << endl;
	cout << "Programmed by Abdullah Al-Salloum and Hussain Al-Sane" << endl;
	cout << "Instructed by: Dr. Ashraf Anwar" << endl;
	cout << "Object-Oriented Programming in C++" << endl;
	cout << "-----------------------------------------------------" << endl;
	cout << "How many students you are going insert in your list? " << '\n';
	cin >> nostbe;
	Student student[nostbe];
	starting(nostbe, student);
	return 0;
}

