/* Object-Oriented Programming in C++   */
/* Student Name: Abdullah S. Al-Salloum */
/* Instructor: Dr. Ashraf Anwar         */

/* Homework Assignment #2               */
/* Modifying the program to let the     */
/* the user to enter the infile and     */
/* outfile names, and choose whether    */
/* to get the results as COUT or in     */
/* outfile.                             */

#include<fstream>
#include<iostream>
#include<string>
#include<cstdlib>       /*To use exit command*/

using namespace std;
const int cuttoff = 6000;
const float rate1 = 0.3;
const float rate2 = 0.6;

int main() {
   ifstream infile;
   ofstream outfile;
   int income, tax, where2show;
   string infilename;
   string outfilename;
   cout << "Enter the name of the InFile: " '\n';
   cin >> infilename;
   cout << "Enter the name of the OutFile: " '\n';
   cin >> outfilename;
   cout << "To show results in screen, press 1" '\n'
        << "To show results in the OutFile, press 2: " '\n';
   cin >> where2show;
   if ( where2show == 1 ) {
      infile.open(infilename.c_str());
      if ( !infile ) {
         cerr << "Unable to open  " << infilename.c_str() << '\n';
         exit( 0 );
      }
      while ( infile >> income ) {
         if ( income < cutoff )
            tax = rate1 * income;
         else
            tax = rate * income;
         cout << "Income = " << income
              << " greenbacks\n"
              << "Tax = " << tax
              << " greenbacks\n";
      }
      infile.close();
   }
   if ( where2show == 2 ) {
      infile.open(infilename.c_str());
      if ( !infile ) {
         cerr << "Unable to open  " << infilename.c_str() << '\n';
         exit( 0 );
      }
      outfile.open(outfilename.c_str());
      if ( !outfile ) {
         cerr << "Unable to open  " << outfilename.c_str() << '\n';
         exit( 0 );
      }
      while ( infile >> income ) {
         if ( income < cutoff )
            tax = rate1 * income;
         else
            tax = rate * income;
         outfile << "Income = " << income
                 << " greenbacks\n"
                 << "Tax = " << tax
                 << " greenbacks\n";
      }
      infile.close();
      outfile.close();
   }
   else {
      cout << "You have entered an unknown digit of showing results place.";
   }
   return 0;
}